/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CyDesigner.Extensions.Common;
using CyDesigner.Extensions.Gde;

// The namespace is required to have the same name as the component for a customizer.
namespace ControlReg32_v0_0
{
    class CyCustomizer : ICyShapeCustomize_v1
    {
        
        const string OUTPUT_TERM_NAME  = "ctrl"; // terminal "ctrl"


        public CyCustErr CustomizeShapes(ICyInstQuery_v1 instQuery, ICySymbolShapeEdit_v1 shapeEdit,
            ICyTerminalEdit_v1 termEdit)
        {
            CyCustErr err;

            // We leave the symbol as it is for symbol preview
            if (instQuery.IsPreviewCanvas)
                return CyCustErr.OK;
            
           
            // Read Parameters
            CyCompDevParam outWidthParam = instQuery.GetCommittedParam("bus_width");
            byte outWidth = byte.Parse(outWidthParam.Value);
            byte maxOutBitIndex = (byte)(outWidth - 1);
            string outTermName = termEdit.GetTermName(OUTPUT_TERM_NAME);
            
            if (maxOutBitIndex != 0)
                err = termEdit.TerminalRename(outTermName, string.Format("{0}[{1}:0]", OUTPUT_TERM_NAME, maxOutBitIndex.ToString())); 
            else
                err = termEdit.TerminalRename(outTermName, string.Format("{0}", OUTPUT_TERM_NAME ));   
     
            if (err.IsNotOK) return err; 
            
            
            

            return CyCustErr.OK;
        }
    } 
}

//[] END OF FILE
