
//`#start header` -- edit after this line, do not edit this line
// ========================================
//
// Copyright YOUR COMPANY, THE YEAR
// All Rights Reserved
// UNPUBLISHED, LICENSED SOFTWARE.
//
// CONFIDENTIAL AND PROPRIETARY INFORMATION
// WHICH IS THE PROPERTY OF your company.
//
// ========================================
`include "cypress.v"
//`#end` -- edit above this line, do not edit this line
// Generated on 03/14/2017 at 20:44
// Component: StatusReg32_v0_0
module StatusReg32_v0_0 (
	output  isr,
	input   clk,
	input   status // variable width input
);

	
    
    // Width parameters //

    parameter [7:0] bus_width = 8'd8; // [4:0] is sufficient - no effect
    localparam  hi = bus_width - 1;     // high index        

    //wire [hi:0] status;
    wire [31:0] status;
    
    localparam SM_TRANSPARENT = 1'b0;  // 
    localparam SM_STICKY      = 1'b1;  // 
    parameter status_mode = SM_TRANSPARENT;
    
    parameter isr_enable = 1'b0;
    parameter isr_mask = 32'hFFFFFFFF;
    localparam [6:0] isr_mask0 = (isr_mask    ) & 7'b1111111;
    localparam [6:0] isr_mask1 = (isr_mask>>7 ) & 7'b1111111;
    localparam [6:0] isr_mask2 = (isr_mask>>14) & 7'b1111111;
    localparam [6:0] isr_mask3 = (isr_mask>>21) & 7'b1111111;
    

//`#start body` -- edit after this line, do not edit this line


    wire [31:0] tmp = status;
    //wire [hi:0] tmp = status;
    
    //todo: 3 warnings-> make conditional generation
    //wire [3:0] isr_bus;
    //assign isr = |isr_bus[3:0]; // combine bits
    //wire [3:0] isr_bus_t = isr_w; //intermediate bus
    //assign isr = |isr_bus_t[3:0]; // combine bits
    //wire isr0, isr1, isr2, isr3;
    //assign isr = isr0 | isr1 | isr2 | isr3;
    
    // all interrupts are combined ("or"-ed)
    wire isr0, isr1, isr2, isr3;
    generate
    if (bus_width > 21) assign isr = isr0 | isr1 | isr2 | isr3;     else
    if (bus_width > 14) assign isr = isr0 | isr1 | isr2;            else
    if (bus_width >  7) assign isr = isr0 | isr1;                   else
                        assign isr = isr0 ;     
    endgenerate
    
    //wire [isr_hi:0] isr_bus;
    //assign isr = |isr_bus[isr_hi:0]; // combine bits
    
    // todo: cy_psoc3_status bug - unused registers are not automatically removed in sticky mode
    localparam mode = (status_mode==SM_TRANSPARENT)? 8'h00 : 8'hFF; // transparent (0) or sticky (1) mode

    generate                                
    if (isr_enable == 1'b0) begin: sStatus         // interrupt disabled
        
        //forcing removal of unused cells (no auto removal in sticky mode)->
        if (bus_width > 8'd0) begin: byte0
            cy_psoc3_status #(.cy_force_order(`TRUE), .cy_md_select(mode))
            Status (
            /*  input  [07:00]  */  .status(status[7:0]),      // Status Bits [7:0]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk));           // Clock for registering data
        end
         
        if (bus_width > 8'd8) begin: byte1   
            cy_psoc3_status #(.cy_force_order(`TRUE), .cy_md_select(mode))
            Status (
            /*  input  [07:00]  */  .status(status[15:8]),     // Status Bits [15:8]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk));           // Clock for registering data
        end
        
        if (bus_width > 8'd16) begin: byte2  
            cy_psoc3_status #(.cy_force_order(`TRUE), .cy_md_select(mode))
            Status (
            /*  input  [07:00]  */  .status(status[23:16]),    // Status Bits [23:16]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk));           // Clock for registering data
        end    
        
        if (bus_width > 8'd24) begin: byte3  
            cy_psoc3_status #(.cy_force_order(`TRUE), .cy_md_select(mode))
            Status (
            /*  input  [07:00]  */  .status(status[31:24]),    // Status Bits [31:24]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk));           // Clock for registering data 
        end
        
    end
    else begin : sStatus         // interrupt enabled
    
        //forcing removal of unused cells (no auto removal in sticky mode)->
        if (bus_width > 8'd0) begin: byte0
            cy_psoc3_statusi #(.cy_force_order(`TRUE), .cy_md_select(mode), .cy_int_mask(isr_mask0))
            Status (
            /*  input  [06:00]  */  .status(tmp[6:0]),      // Status Bits [6:0]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk),            // Clock used for registering data
            /*  output          */  //.interrupt(isr_bus[0]));// Interrupt signal (route to Int Ctrl)
            /*  output          */  .interrupt(isr0));  // Interrupt signal (route to Int Ctrl)
        end
         
        if (bus_width > 8'd7) begin: byte1   
            cy_psoc3_statusi #(.cy_force_order(`TRUE), .cy_md_select(mode), .cy_int_mask(isr_mask1))
            Status (
            /*  input  [06:00]  */  .status(tmp[13:7]),     // Status Bits [14:7]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk),            // Clock used for registering data
            /*  output          */  //.interrupt(isr_bus[1]));// Interrupt signal (route to Int Ctrl)
            /*  output          */  .interrupt(isr1));  // Interrupt signal (route to Int Ctrl)
        end
        
        if (bus_width > 8'd14) begin: byte2     
            cy_psoc3_statusi #(.cy_force_order(`TRUE), .cy_md_select(mode), .cy_int_mask(isr_mask2))
            Status (
            /*  input  [06:00]  */  .status(tmp[20:14]),    // Status Bits [14:7]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk),            // Clock used for registering data
            /*  output          */  //.interrupt(isr_bus[2]));// Interrupt signal (route to Int Ctrl)
            /*  output          */  .interrupt(isr2));  // Interrupt signal (route to Int Ctrl)
        end    
        
        if (bus_width > 8'd20) begin: byte3      
            cy_psoc3_statusi #(.cy_force_order(`TRUE), .cy_md_select(mode), .cy_int_mask(isr_mask3))
            Status (
            /*  input  [06:00]  */  .status(tmp[27:21]),    // Status Bits [14:7]
            /*  input           */  //.reset(),               // Reset from interconnect
            /*  input           */  .clock(clk),            // Clock used for registering data
            /*  output          */  //.interrupt(isr_bus[3]));// Interrupt signal (route to Int Ctrl)
            /*  output          */  .interrupt(isr3));  // Interrupt signal (route to Int Ctrl)
        end   
            
    end
    endgenerate

//`#end` -- edit above this line, do not edit this line
endmodule
//`#start footer` -- edit after this line, do not edit this line
//`#end` -- edit above this line, do not edit this line

